package org.ugasp.location.server;

import java.awt.Point;

import org.ugasp.location.server.openmap.LLXY;
import org.ugasp.location.server.openmap.LatLonPoint;

public class Projection {

	private static final int[] YAHOO_ZOOM_SCALE = new int[]{ 4625, 9250, 18500, 37000, 74000, 148000,
		 296000, 592000, 0, 0, 0, 0,
		 0, 0, 0, 0, 0 };

	private static LatLonPoint center;
	private static double latCenter;
	private static LLXY ll2XYProjection;
	
	
	public static void initLL2XY(double lat, double lon, int screen_width, int screen_height, int zoom){
		latCenter = lat;
		center = new LatLonPoint(lat, lon);
		ll2XYProjection = new LLXY(center,YAHOO_ZOOM_SCALE[zoom-1],screen_width,screen_height);
	}
	
	public static Point LL2XYProjection(double lat, double lon){
		Point p = new Point();
		return ll2XYProjection.forward((float)lat, (float)lon, p);
	}
	
	public static double errorAdjustement(double latCoord){
		return latCoord +(latCoord-latCenter)*0.53;
	}
}
