/***
 * GASP: a gaming services platform for mobile multiplayer games.
 * MooDS: a communication protocol used in GASP.
 * GASP Demonstrator: a gasp demonstration game.
 *
 * Copyright (C) 2004 CNAM/INT
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: gasp-team@objectweb.org
 *
 * Author: Franck Caron, Romain Pellerin
 */
/*
 * Created on 2 december 2005
 *
 * @author CARON Franck - CNAM CEDRIC
 * @author PELLERIN Romain - CNAM CEDRIC
 * 
 * 
 * Research project: CNAM-CEDRIC - INT - Filao
 */
//#include parameters.h
////////////////////////
// Game params        //
////////////////////////

////#define PING
////#define VIRTUAL_WORLD_MAP
//#endinclude

/*
 * Created on 15 fvr. 200
 * 
 */

package org.ugasp.games.demonstrator;


/**
 * @author PELLERIN Romain (CNAM Paris, romain.pellerin@laposte.net)
 * @author DELPIANO Fabien (Pastagames, fabien@pastaga.net)
 * @author KOCIK Fabrice - (Pastagames, fabrice@pastis.org)
 * @author CARON Franck (CNAM Paris)
 * --
 * JIMM Project 2005
 * (Bouygues Telecom, CNAM Paris, Pastagames)
 */
public class Player {
    
	// traditional vars
    private int id;
    private int x;
    private int y;
    private int speedX;
    private int speedY;

	//#ifdef REAL_WORLD_MAP
    // location based vars
    private double latitude;
    private double longitude;
    public int zoom;
    private int mapWidth;
    private int mapHeight;
    private double mapCenterLatitude;
    private double mapCenterLongitude;
    
	public boolean locationReceived;
	public boolean mapRequestReceived;
	//#endif REAL_WORLD_MAP
    
    private String username;
    private boolean readyToReceive = false;
   // private boolean lock = false;
    
    private boolean resInfosPlayerReceived = true;
    public boolean reconnection = false;
    
    public int maxActor;
     
    public boolean[] infosPlayerReceived = {false};
	
    public Player(int _id, String _username){
        id = _id;
        username = _username;
        
		//#ifdef REAL_WORLD_MAP
        locationReceived = false;
        mapRequestReceived = false;
		//#endif REAL_WORLD_MAP 
    } 
    
    public Player(int _id){
        id = _id; 
     }
    /*******************************/
    /** Informations for the game **/
    /*******************************/
    
    public int getId(){return id;}
	public void setId(int id1){id=id1;}
    
    public int getX(){return x;}
    public void setX(int x1){x=x1;}
        
    public int getY(){return y;}
    public void setY(int y1){y=y1;}
    
    public int getSpeedX() {return speedX;}
    public void setSpeedX(int speedX1) {speedX=speedX1;}
    
    public int getSpeedY() {return speedY;}
    public void setSpeedY(int speedY1) {speedY=speedY1;}
    
    public String getUsername(){return username;}
    public void setUsername(String _username){username=_username;}
    

	//#ifdef REAL_WORLD_MAP
    public double getLatitude() {return latitude;}
	public void setLatitude(double latitude) {this.latitude = latitude; locationReceived  = true;}

	public double getLongitude() {return longitude;}
	public void setLongitude(double longitude) {this.longitude = longitude; locationReceived  = true;}   

	public int getZoom() {return zoom;}
	public void setZoom(int zoom) {this.zoom = zoom;}
	
	public int getMapWidth() {return mapWidth;}
	public void setMapWidth(int mapWidth) {this.mapWidth = mapWidth;}

	public int getMapHeight() {return mapHeight;}
	public void setMapHeight(int mapHeight) {this.mapHeight = mapHeight;}

	public double getMapCenterLatitude() {return mapCenterLatitude;}
	public void setMapCenterLatitude(double mapCenterLatitude) {this.mapCenterLatitude = mapCenterLatitude;  mapRequestReceived  = true;}

	public double getMapCenterLongitude() {return mapCenterLongitude;}
	public void setMapCenterLongitude(double mapCenterLongitude) {this.mapCenterLongitude = mapCenterLongitude;  mapRequestReceived  = true;}
	//#endif REAL_WORLD_MAP
	
	
    /**
     * return true if the message new player of this player were received and treated.
     * @return
     */
    public boolean isReadyToReceive() { return readyToReceive;}
    public void setReadyToReceive(boolean b) { readyToReceive = b;}
    
    
    /***********************************/
    /** management of the reconnexion **/
    /***********************************/
    
    public boolean isAReconnection(){ return reconnection;}

      
    public boolean isAllInfosPlayersConnectedReceived (){
        /* TODO  loop for reading all the content of the boolean[] InfosPlayerReceived*/

		for (int i = 0; i < maxActor; i++) {
			resInfosPlayerReceived = resInfosPlayerReceived && infosPlayerReceived[i];
		}
		return resInfosPlayerReceived;
    }
    
    public boolean isInfosPlayerReceived (int playerID){
        return infosPlayerReceived[playerID];
    }
    
    public void setReceiveOfPlayerInfos (int playerID, boolean b){
        infosPlayerReceived[playerID] = b;
    }


}
